/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.applications.adaptiveTL;

public class IntersectionPhaseStatistics {
	
	int phaseStartFrame;
	int phaseEndFrame = -1;
	int color;
	
	int carsNo;
	int demandCarsNo;
	int leftDemandCarsNo;
	double avgSpeed;
	double queueSize;
	double avgNoOfStops;
	int avgControlDelay;
	double queueDischargeRate;
	double avgGap;
	
	public IntersectionPhaseStatistics(int crtTime, int color){
		this.phaseStartFrame = crtTime;
		this.color = color;
		carsNo = 0;
		demandCarsNo = 0;
		leftDemandCarsNo = 0;
		avgSpeed = 0;
		queueSize = -1;
	}

	public void setAvgSpeed(double avgSpeed) {
		this.avgSpeed = avgSpeed;
	}

	public void setCarsNo(int carsNo) {
		this.carsNo = carsNo;
	}

	public void setQueueSize(double queueSize) {
		this.queueSize = queueSize;
	}

	public void setPhaseEndFrame(int phaseEndFrame) {
		this.phaseEndFrame = phaseEndFrame;
	}

	public double getAvgSpeed() {
		return avgSpeed;
	}

	public int getCarsNo() {
		return carsNo;
	}

	public double getQueueSize() {
		return queueSize;
	}

	public int getPhaseEndFrame() {
		return phaseEndFrame;
	}

	public int getPhaseStartFrame() {
		return phaseStartFrame;
	}

	public double getAvgNoOfStops() {
		return avgNoOfStops;
	}

	public void setAvgNoOfStops(double avgNoOfStops) {
		this.avgNoOfStops = avgNoOfStops;
	}

	public int getColor() {
		return color;
	}

	public void setColor(int color) {
		this.color = color;
	}
	
	
}
