package vnsim.applications.ezcab;

/**
 * Mazilu Sinziana
 * 
 * Class for EZCab ACK Message
 * _________________________________________________________________
 * |            |              |           |           	 |         |  
 * | EZCab PROT | Type Message | ID Client | ID Free Cab | NO HOPS |
 * |____________|______________|___________|_____________|_________|
 * 
 **/

public class EzcabAck extends EzcabMessage{

	private int idClient;
	private int idCab;
	private int noHops;
	
	public EzcabAck(byte protType, int messageType, int idClient, int idCab, int noHops) {
		super(protType, messageType);
		this.idClient 	= idClient;
		this.idCab 		= idCab;
		this.noHops		= noHops;
	}

	public int getIdClient() {
		return idClient;
	}

	public void setIdClient(int idClient) {
		this.idClient = idClient;
	}

	public int getIdCab() {
		return idCab;
	}

	public void setIdCab(int idCab) {
		this.idCab = idCab;
	}

	public int getNoHops() {
		return noHops;
	}

	public void setNoHops(int noHops) {
		this.noHops = noHops;
	}
	
	public String toString(){
		return "Ack:" + this.getProtType() + " - " + this.getMessageType() + " - " + this.getIdClient() + " - " + this.getIdCab() + " - " + this.getNoHops();
	}
}
