
/**
 * Mazilu Sinziana
 * 
 * EZCab Implementation
 * EZCab Global Constants
 * 
 * */

package vnsim.applications.ezcab;

/**
 * 
 * EZCab Globals Class
 *
 */

public class EzcabGlobals {

	/* client doesn't have a preference in choosing a network */
	public static final int DEFAULT_NETWORK = 0;
	/* a general ID of a client */
	public static final int DEFAULT_CLIENT  = 0;
	
	/* state of a cab - may be occupied or free */
	public static final int FREE_STATE 		= 0;
	public static final int BUSY_STATE		= 1;
	public static final int WAITING_STATE	= 2;
	//public static final int NONE_STATE 		= -1;
	
	/* timeout constant */
	public static final long TIMEOUT		= 10 * 60 * 1000L;
	/* max hops constant */
	public static final int MAX_HOPS		= 100; 		
	/* max distance constant between client and cab */
	public static final int MAX_DIST		= 3000;    
	
	/* type of entity constants: client or cab */
	public static final byte CLIENT			= 0;
	public static final byte CAB			= 1; 
	
	/* sending time constant for cab entity, who doesn't have normally sending time */
	public static final float CAB_SENDING_TIME = -1;
	
	/* type of messages */
	public static final int REQUEST			= 0;
	public static final int RESPONSE		= 1;
	public static final int ACK				= 2;
	
}
