package vnsim.applications.ezcab;

import java.io.Serializable;

import vnsim.map.object.Globals;

/**
 * Mazilu Sinziana
 * 
 * Class for EZCab Message Header
 * _____________________________
 * |            |              | 
 * | EZCab PROT | Type Message |
 * |____________|______________|
 * 
 **/

public class EzcabMessage implements Serializable {
	
	public byte 	protType;
	public int 		messageType;
	
	public EzcabMessage(byte protType, int messageType) {
		this.protType 	 = protType;
		this.messageType = messageType;
	}
	
	public EzcabMessage(){
		this.protType 	 = Globals.PROT_EZCAB;
		this.messageType = 0;
	}
	
	public EzcabMessage(int messageType){
		this.protType 	 = Globals.PROT_EZCAB;
		this.messageType = messageType;
	}

	public byte getProtType() {
		return protType;
	}

	public void setProtType(byte protType) {
		this.protType = protType;
	}

	public int getMessageType() {
		return messageType;
	}

	public void setMessageType(byte messageType) {
		this.messageType = messageType;
	}

}
 