package vnsim.applications.ezcab;

/**
 * Mazilu Sinziana
 * 
 * Class for EZCab Request Message
 * ____________________________________________________________________
 * |            |              |           |         |                 |
 * | EZCab PROT | Type Message | ID Client | NO HOPS | TIME OF SENDING |
 * |____________|______________|___________|_________|_________________|
 * 
 **/

public class EzcabRequest extends EzcabMessage {
	
	private int idClient;
	private int noHops;
	private int timeOfSending;
	
	public EzcabRequest(byte protType, int messageType, int idClient, int noHops, int ts) {
		super(protType, messageType);
		this.idClient	= idClient;
		this.noHops 	= noHops;
		this.timeOfSending = ts;
	}

	public int getIdClient() {
		return idClient;
	}

	public void setIdClient(int idClient) {
		this.idClient = idClient;
	}

	public int getNoHops() {
		return noHops;
	}

	public void setNoHops(int noHops) {
		this.noHops = noHops;
	}
	
	public int getTimeOfSending() {
		return timeOfSending;
	}

	public void setTimeOfSending(int timeOfSending) {
		this.timeOfSending = timeOfSending;
	}

	public String toString(){
		return "Request: " + this.getProtType() + " - " + this.getMessageType() + " - " + this.getIdClient() + " - " + this.getNoHops();
	}
	
}
