/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.core.events;

/**
 * Class that holds information about a simulation event.
 *
 */
public class Event implements Comparable<Event>{
	int time;
	
	public Event(int time) {
		this.time = time;
	}
	
	public int compareTo(Event e){
		return time - e.time;
	}

	public boolean equals(Object e){
		if (!(e instanceof Event)) {
			return false;
		}
		Event ev = (Event) e;
		return time == ev.time;
	}

	public int getTime() {
		return time;
	}

	public void setTime(int time) {
		this.time = time;
	}
	
	
	
}
