/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.core.events;

import java.io.Serializable;

import vnsim.core.Communicator;

public class SendEvent extends Event{
	public Communicator sender;
	int messageType;
	byte[] message;
	
	Serializable messageObject;
	
	public SendEvent(int t, Communicator sender, int messageType){
		super(t);
		this.sender = sender;
		this.messageType = messageType;
	}

	public byte[] getMessage() {
		return message;
	}

	public void setMessage(byte[] message) {
		this.message = message;
	}

	public Serializable getMessageObject() {
		return messageObject;
	}
	
	public void setMessageObject(Serializable m) {
		messageObject = m;
	}
	
	public Communicator getSender() {
		return sender;
	}

	public void setSender(Communicator sender) {
		this.sender = sender;
	}

	public int getMessageType() {
		return messageType;
	}

	public void setMessageType(int messageType) {
		this.messageType = messageType;
	} 
	
	public String toString() {
		return "["+time+": Bcast "+sender+" ]";
	} 

}
