package vnsim.gui;

public class MyColor {

	public static final MyColor color_InterstatalHighway = new MyColor(1.0f, 0.7f, 0.7f);
	public static final MyColor color_StatalHighway = new MyColor(1.0f, 0.8f, 0.5f);
	public static final MyColor color_PrimaryRoad = new MyColor(1.0f, 0.8f, 0.5f);
	public static final MyColor color_SecondaryRoad = new MyColor(1.0f, 1.0f, 0.55f);
	public static final MyColor color_LocalRoad = new MyColor(0.82f, 0.82f, 0.82f);
	public static final MyColor color_VehicularTrail = new MyColor(0.7f, 0.6f, 0.2f);
	public static final MyColor color_AccessRamp = new MyColor(0.9f, 0.9f, 0.4f);
	public static final MyColor color_PedestrianRoad = new MyColor(0.4f, 1.0f, 0.4f);
	public static final MyColor color_DefaultRoad = new MyColor(1.0f, 0.0f, 0.0f);
	public static final MyColor color_SemaphoreRed = new MyColor(1.0f, 0.0f, 0.0f);
	public static final MyColor color_SemaphoreYellow = new MyColor(1.0f, 0.8f, 0.5f);
	public static final MyColor color_SemaphoreGreen = new MyColor(0.0f, 1.0f, 0.0f);

	private float red = 0f;
	private float blue = 0f;
	private float green = 0f;

	/**
	 * Builds a new MyColor object.
	 * 
	 * @param red
	 *            RED component of the new color.
	 * @param green
	 *            GREEN component of the new color.
	 * @param blue
	 *            BLUE component of the new color.
	 */
	public MyColor(float red, float green, float blue) {
		this.red = red;
		this.green = green;
		this.blue = blue;
	}

	/**
	 * 
	 * @return RED component of this color.
	 */
	public float getRed() {
		return red;
	}

	/**
	 * 
	 * @param red
	 *            New RED component.
	 */
	public void setRed(float red) {
		this.red = red;
	}

	/**
	 * 
	 * @return BLUE component of this color.
	 */
	public float getBlue() {
		return blue;
	}

	/**
	 * 
	 * @param blue
	 *            New BLUE component.
	 */
	public void setBlue(float blue) {
		this.blue = blue;
	}

	/**
	 * 
	 * @return GREEN component of this color.
	 */
	public float getGreen() {
		return green;
	}

	/**
	 * 
	 * @param green
	 *            New GREEN component.
	 */
	public void setGreen(float green) {
		this.green = green;
	}

	public static MyColor chooseRoadColor(int roadType) {
		switch (roadType) {
		case 49:// interstatal highway
			return color_InterstatalHighway;

		case 50:// statal highway and primary road
			return color_StatalHighway;

		case 51:// secondary road
			return color_PrimaryRoad;

		case 52: // local road
			return color_LocalRoad;

		case 53:// vehicular trail
			return color_VehicularTrail;

		case 54:// access ramp
			return color_AccessRamp;

		case 55:// pedestrian road
			return color_PedestrianRoad;

		default:
			return color_DefaultRoad;
		}
	}

	protected static MyColor chooseSemaphoreColor(int color) {
		switch (color) {
		case 1:
			return color_SemaphoreRed;
		case 2:
			return color_SemaphoreYellow;
		case 3:
			return color_SemaphoreGreen;
		default:
			return color_SemaphoreRed;
		}
	}
}
