/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
//Petroaca - a data packet at the physical level
package vnsim.network.dsrc;

import vnsim.map.object.Globals;

public class DsrcPacket
{
	private byte[] preamble;
	private byte[] PCLPHeader;
	private DsrcFrame frame;
	
	public DsrcPacket()
	{
		this.preamble=new byte[Globals.DSRC_PREAMBLE_LENGTH];
		this.PCLPHeader=new byte[Globals.DSRC_PHYHEADER_LENGHT];
		this.frame=new DsrcFrame();
	}
	
	public DsrcPacket(byte[] preamble,byte[] PCLPHeader,DsrcFrame frame)
	{
		this.preamble=preamble;
		this.PCLPHeader=PCLPHeader;
		this.frame=frame;
	}
	
	public byte[] getPCLPHeader()
	{
		return this.PCLPHeader;
	}
	
	public void setPCLPHeader(byte[] set)
	{
		this.PCLPHeader=set;
	}
	
	public byte[] getPreamble()
	{
		return this.preamble;
	}
	
	public void setPreamble(byte[] set)
	{
		this.preamble=set;
	}
	
	public DsrcFrame getFrame()
	{
		return this.frame;
	}
	
	public void setFrame(DsrcFrame set)
	{
		this.frame=set;
	}
	
	public String toString()
	{
		return "Preamble : "+this.preamble+" Phy Header:"+this.PCLPHeader+" "+this.frame.toString();
	}
}