package vnsim.network.scft;

/**
 * @author Serban George-Cristian Structura mesajului
 */

public class MesageSCFT {

	public int vehicleIdSource;
	public int vehicleIdDest;
	public long carIdSourceH;
	public long carIdSourceV;
	public long carIdDestH;
	public long carIdDestV;
	public long timeStamp;
	public int ttl;


	/**
	 * 
	 * @param vehicleIdSource
	 *            - id vehicul sursa
	 * @param vehicleIdDest
	 *            - id vehicul destinatie
	 * @param carIDSourceH
	 *            - pozitia orizontala a vehicului sursa
	 * @param carlIdSourceV
	 *            - pozitia verticala a vehicului sursa
	 * @param carlIdDestH
	 *            - pozitia orizontala a vehicului destinatie
	 * @param carlIdDestV
	 *            - pozitia verticala a vehicului destinatie
	 * @param timeStamp
	 *            - timpul de sosire a mesajului - secunde
	 * @param TTL
	 *            - TTL definit
	 */
	public MesageSCFT(int vehicleIdSource, int vehicleIdDest, long carIdSourceH, long carlIdSourceV,
			long carIdDestH,	long carIdDestV, long timeStamp, int ttl) {
		this.vehicleIdSource = vehicleIdSource;
		this.vehicleIdDest = vehicleIdDest;
		this.carIdSourceH = carIdSourceH;
		this.carIdSourceV = carlIdSourceV;
		this.carIdDestH = carIdDestH;
		this.carIdDestV = carIdDestV;
		this.timeStamp = timeStamp;
		this.ttl = ttl;

	}

	public long getTimeStamp() {
		return timeStamp;
	}

	public void setTimeStamp(int timeStamp) {
		this.timeStamp = timeStamp;
	}

	public int getVehicleIdSource() {
		return vehicleIdSource;
	}

	public void setVehicleIdSource(int vehicleIdSource) {
		this.vehicleIdSource = vehicleIdSource;
	}

	public int getVehicleIdDest() {
		return vehicleIdDest;
	}

	public void setVehicleIdDest(int vehicleIdDest) {
		this.vehicleIdDest = vehicleIdDest;
	}

	public long getCarIdSourceH() {
		return carIdSourceH;
	}

	public void setCarIdSourceH(int carIdSourceH) {
		this.carIdSourceH = carIdSourceH;
	}

	public long getCarIdSourceV() {
		return carIdSourceV;
	}

	public void setCarIdSourceV(int carIdSourceV) {
		this.carIdSourceV = carIdSourceV;
	}

	public long getCarIdDestH() {
		return carIdDestH;
	}

	public void setCarIdDestH(int carIdDestH) {
		this.carIdDestH = carIdDestH;
	}

	public long getCarIdDestV() {
		return carIdDestV;
	}

	public void setCarIdDestV(int carIdDestV) {
		this.carIdDestV = carIdDestV;
	}

	public int getTtl() {
		return ttl;
	}

	public void setTtl(int ttl) {
		this.ttl = ttl;
	}

}
