package vnsim.socialNet;

import java.util.ArrayList;
import vnsim.map.object.Point;
import vnsim.vehicular.simulator.Location;

public class CellInformation {
	int numberOfHosts;
	Point pointMax, pointMin;
	boolean okToUse;
	ArrayList<Point> validPoints;
	ArrayList<Location> validLocations; 
	int priorityEntry;
	int priorityExit;
	
	public CellInformation(){
		numberOfHosts = 0;
		okToUse = false;
		pointMin = new Point((double) 180, (double) 90);
		pointMax = new Point((double) -180, (double) -90);
		validPoints = new ArrayList<Point>();
		validLocations = new ArrayList<Location>();
		priorityEntry = 10;
		priorityExit = 10;
	}
	
	public void setPriorityEntry(int p){
		priorityEntry = p;
	}
	
	public void setPriorityExit(int p){
		priorityExit = p;
	}
	
	public void setMaxPoint(double lon, double lat){
		pointMax.setLatitude(lat);
		pointMax.setLongitude(lon);
	}
	
	public void setMinPoint(double lon, double lat){
		pointMin.setLatitude(lat);
		pointMin.setLongitude(lon);
	}
	
	public void addValidPoint(Point p){
		validPoints.add(p);
	}
	
	public Point getValidPoint(int i){
		return validPoints.get(i);
	}

	public void addValidLocation(int road,int point){
		validLocations.add(new Location(road,point));
	}
	
	public Location getValidLocation(int i){
		return validLocations.get(i);
	}
	
	
	public int getNoPoints(){
		if(validPoints.size()<validLocations.size())
			return validPoints.size();
		return validLocations.size();
	}
	
	public void setHosts(int val){
		numberOfHosts = val;
	}
	
	public void incHosts(){
		numberOfHosts = numberOfHosts + 1;
	}
	
	public void enable(){
		this.okToUse = true;
	}
	
	public void disable(){
		this.okToUse = false;
	}
	
	public boolean isAvailable(){
		return okToUse;
	}

}
