package vnsim.socialNet;

import java.util.ArrayList;
import vnsim.map.object.Point;
import vnsim.map.object.Road;
import vnsim.vehicular.simulator.Location;

public class NodeInformation {
	int nodeId;
	ArrayList<Integer> adjacency = new ArrayList<Integer>();
	double interaction[];
	int nrHosts;
	
	int cellX;
	int cellY;
	
	Point start;
	Location startLoc;
	
	public NodeInformation(int id, int nrHosts){
		nodeId = id;
		this.nrHosts = nrHosts;
		interaction = new double[nrHosts];
		for(int i=0;i<nrHosts;i++){
			interaction[i] = 0;
		}
	}
	
	public void setIneraction(int id, double val){
		interaction[id] = val;
	}
	
	public double getIneraction(int id){
		return interaction[id];
	}
	
	public int getAdjacency(int id){

		return adjacency.get(id).intValue();
	}
	
	public void setAdjacency(int id, int val){
		adjacency.set(id, val);
	}
	
	public void generateAdjacency(){
	
		for (int i=0; i<nrHosts; i++)  
				if (interaction[i]>GlobalNetwork.THESHOLD)
					adjacency.add(new Integer(1));    
				else
					adjacency.add(new Integer(0)); 

	}
	
	public void deleteLink(int id){
		interaction[id]=0;
	}
		
	public void addStartPoint(Point p){
		start = p;
	}
	
	public void addStartLocation(Location l){
		startLoc = l;
	}
	
	public Location getLocation(){
		return startLoc;
	}
	
	public Point getPoint(){
		return start;
	}
}
