/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.generator;


import java.util.ArrayList;

import vnsim.vehicular.simulator.CarInstance;


public class SortedEventsVector {	

	private ArrayList<NewCarEvent> theArray;	
	
	public SortedEventsVector() {
		theArray=new ArrayList<NewCarEvent>();
	}

	public int size() {
		return theArray.size();
	}
	
	public String toString() {
		String ret=" [ ";
		for(int i=0;i<theArray.size();i++) {
			ret=ret+" ( "+ theArray.get(i)+" ) ; ";
		}
		ret+=" ] ";
		return ret;
	}
	
	public NewCarEvent removeFirst() {
		if(size()==0)
			return null;
		return theArray.remove(0);
	}

	public NewCarEvent first() {
		if(size()==0)
			return null;
		return theArray.get(0);
	}

	public void addEvent(NewCarEvent ev) {
		for(int i=0;i<theArray.size();i++) {
			NewCarEvent nev=theArray.get(i);
			if(ev.compareTo(nev)<0) {
				//insert it
				theArray.add(i,ev);
				return;
			}
		}
		theArray.add(ev);
	}
}