/*
 * Author Andrei Ichimescu
 * email andrei.ichimescu@gmail.com
 */

package vnsim.vehicular.routePlan.cityRouting;

import java.util.ArrayList;

import javax.swing.JOptionPane;

import vnsim.vehicular.generator.Mobility;
import vnsim.vehicular.routePlan.MakeScenarios;
import vnsim.vehicular.routePlan.RoutingConstants;
import vnsim.vehicular.scenarios.Scenario;
import vnsim.vehicular.simulator.Location;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//final String name = "RoutePlanCityTest";
		final String name = "Reservation1";
		try{
		MakeScenarios.createMap(name, true, true,
				RoutingConstants.DYNAMIC_CITY_ROUTE);
		}catch(Exception e){
			
		}
		ArrayList<Location> entries = new ArrayList<Location>();
		ArrayList<Location> exits = new ArrayList<Location>();
		ArrayList<Integer> entryFlows = new ArrayList<Integer>();
		
		//entries.add(new Location(0, 0));
		//exits.add(new Location(0, 768));
		//entryFlows.add(400);
		
		for (int i=2;i<=2;i++) {
			entries.add(new Location(i, 0));
			 //entries.add(new Location(i, 768));
			entries.add(new Location(i+5, 0));
			 //entries.add(new Location(i+5, 768));
			 //exits.add(new Location(i, 0));
			exits.add(new Location(i, 768));
			 //exits.add(new Location(i+5, 0));
			exits.add(new Location(i+5, 768));
			for (int j=0; j<2;j++) {
				if (i==2) {
					entryFlows.add(350);
				} else {
					entryFlows.add(100);
				}
			}
		}
		
		Scenario s = MakeScenarios.createScenario(name, entries, exits, entryFlows);
		vnsim.map.object.Globals.variationsFile = null;
		try {
			Mobility.loadScenario(s);
		} catch (Exception ex) {
			JOptionPane.showMessageDialog(null,
					"<html>ERROR! Map structure has been modified<br> Try rebuilding the map "
							+ s.mapFileName + "!</html>");
		}
	}

}
