package vnsim.vehicular.routePlan.cityRouting;

import vnsim.applications.adaptiveTL.WirelessTrafficLight;
import vnsim.map.object.Globals;
import vnsim.vehicular.simulator.intersections.DirectedRoadSegment;
import vnsim.vehicular.simulator.intersections.Intersection;

public class RoadSegmentCost {

	private DirectedRoadSegment roadSegment;
	private Double segmentCost;

	public RoadSegmentCost(DirectedRoadSegment d) {
		roadSegment = d;
		segmentCost = new Double(0);
	}

	public static void initRoadSegmentsCost() {
		int i, j;
		Intersection it;
		DirectedRoadSegment s;
		RoadSegmentCost rsc;
		System.out.println("Starting segmentsCost adding");
		for (i = 0; i < Globals.map.allIntersections.size(); i++) {
			it = Globals.map.allIntersections.get(i);
			if (!(it instanceof WirelessTrafficLight)) {
				continue;
			}
			for (j = 0; j < it.segments.size(); j++) {
				s = it.segments.get(j);
				rsc = new RoadSegmentCost(s);
				if (!Globals.routePlanConstants.segmentsCost.contains(rsc)) {
					Globals.routePlanConstants.segmentsCost.add(rsc);
				}
			}
		}
	}

	public Double getCost() {
		return segmentCost;
	}

	public void setCost(Double cost) {
		segmentCost = cost;
	}

	public boolean equals(RoadSegmentCost r) {
		return roadSegment.equals(r.roadSegment);
	}

	public boolean equals(DirectedRoadSegment r) {
		return roadSegment.equals(r);
	}

}
