package vnsim.vehicular.routePlan.cityRouting;

import java.util.ArrayList;

public class WeekCongestion {
	// congestion for every hour for every day of the week
	private ArrayList<ArrayList<Double>> weekData;

	public WeekCongestion() {
		weekData = new ArrayList<ArrayList<Double>>();
		ArrayList<Double> dayData;
		for (int day = 0; day < 7; day++) {
			dayData = new ArrayList<Double>();
			for (int hour = 0; hour < 24; hour++) {
				dayData.add(new Double(0));
			}
			weekData.add(dayData);
		}
	}

	public WeekCongestion(ArrayList<ArrayList<Double>> data) {
		weekData = data;
	}

	public void setCongestion(int day, int hour, Double congestion) {
		weekData.get(day).set(hour, congestion);
	}

	public Double getCongestion(int day, int hour) {
		return weekData.get(day).get(hour);
	}

	public WeekCongestion cloneWeekCongestion() {
		ArrayList<ArrayList<Double>> cloned = new ArrayList<ArrayList<Double>>();
		ArrayList<Double> dayData;
		for (int day = 0; day < 7; day++) {
			dayData = new ArrayList<Double>();
			for (int hour = 0; hour < 24; hour++) {
				dayData.add(weekData.get(day).get(hour));
			}
			cloned.add(dayData);
		}
		return new WeekCongestion(cloned);
	}

	public String toString() {
		String str = "";
		for (int day = 0; day < 7; day++) {
			for (int hour = 0; hour < 24; hour++) {
				str = str + weekData.get(day).get(hour) + " ";
			}
			str = str + "\n";
		}
		return str;
	}
}
