/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.routePlan.infrastructureRouted;

import vnsim.applications.trafficview.SimulatedCarInfo;
import vnsim.applications.vitp.CarRunningVITP;
import vnsim.map.object.Globals;
import vnsim.vehicular.simulator.CarInstance;

public class GuidanceRequest {

	public static void generateRequestToInfrastructure(CarInstance car) {

		if ((car.route.length <= car.routeIndex + 1)
				&& (Globals.engine.crtTime % 100 == car.queryTime)) {

			SimulatedCarInfo myCar = Globals.engine.getCarIdx(car.ID);
			if (myCar != null) {

				if (!(myCar instanceof InfrastructureNode)) {
					if ((car.route[car.routeIndex].pt2 != car.destination.ptIdx)
							|| (car.route[car.routeIndex].roadIndex != car.destination.roadIdx)) {

						((CarRunningVITP) myCar).broadcastRoadPacket("DR "
								+ car.ID + " "
								+ car.route[car.routeIndex].roadIndex + " "
								+ car.route[car.routeIndex].pt1 + " "
								+ car.route[car.routeIndex].pt2 + " "
								+ car.destination.roadIdx + " " + car.destination.ptIdx);

					}

				}
			}
		}

	}

}