/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.scenarios;


import java.util.Vector;

import vnsim.vehicular.simulator.Location;


public class EntryScenario implements java.io.Serializable {
	
	/** <code>serialVersionUID</code> */
	private static final long serialVersionUID = -5883719321862303634L;

	public Location entry;

	public int flow; // vehicles/hour

	public Vector<Integer> percentsDriverTypes;

	public Vector<EntryExitScenario> entryExits;

	
	public EntryScenario(Location entry) {
		this.entry = entry;
		this.flow = 0;
		this.percentsDriverTypes=new Vector<Integer>();
		this.entryExits=new Vector<EntryExitScenario>();
	}

	public boolean equals(EntryScenario es) {
		if (entry.equals(es.entry)) {
			return true;
		} else {
			return false;
		}
	}
	
	public EntryExitScenario getEntryExitScenarioForExit(Location l){
		EntryExitScenario exs=null;
		
		for(int i=0;i<this.entryExits.size();i++){
			if(this.entryExits.elementAt(i).exit.equals(l)){
				exs=this.entryExits.elementAt(i);
				break;
			}
		}	
		return exs;
	}
	
	
}