/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.scenarios;




import java.util.ArrayList;

import vnsim.map.object.*;
import vnsim.vehicular.simulator.Location;
import vnsim.vehicular.simulator.RouteSegment;


public class Scenario implements java.io.Serializable {
	
	/** <code>serialVersionUID</code> */
	private static final long serialVersionUID = -5883719321862303634L;

	public String name;
//	public Map theMap;
	
	public String mapFileName;
	
	public ArrayList<Route> allRoutes;
	public ArrayList<String> driverTypes;

	public ArrayList<Location> entries;

	public ArrayList<Location> exits;

	public ArrayList<EntryScenario> entryScenarios;


	public Scenario(String mapFileName, ArrayList<Location> entries, ArrayList<Location> exits,
			ArrayList<String> driverTypes,ArrayList<Route> allRoutes,String name) 
	{
		//this.theMap = map;
		
		this.mapFileName=mapFileName;
		
		this.driverTypes = driverTypes;
		this.entries = entries;
		this.exits = exits;
		this.entryScenarios=new ArrayList<EntryScenario>();
		this.allRoutes=allRoutes;
		this.name=name;

	}

	public int contains(Location entry) {
		if (entryScenarios == null) {
			return -1;
		} else {
			int i;
			for (i = 0; i < entryScenarios.size(); i++) {
				if (entryScenarios.get(i).entry.equals(entry)) {
					return i;
				}
			}
			return -1;
		}
	}

	public EntryScenario getEntryScenario(int id) {
		if (entryScenarios == null) {
			return null;
		} else {
			if (entryScenarios.size() < id) {
				return null;
			} else {
				return entryScenarios.get(id);
			}
		}
	}

}
