/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.scenarios;



import java.util.ArrayList;

import vnsim.map.object.*;
import vnsim.vehicular.simulator.Location;
import vnsim.vehicular.simulator.RouteSegment;


public class ScenarioMap implements java.io.Serializable {

	/** <code>serialVersionUID</code> */
	private static final long serialVersionUID = -5883719321862303634L;
	public String name;
	public String imageFileName;
	public String mapFileName;
	public ArrayList<Location> entries;
	public ArrayList<Location> exits;
	public ArrayList<Route> allRoutes;
	public ArrayList<String> driverTypes;
	
	public ScenarioMap(){
	}
	
	public ScenarioMap(Scenario s){
		this.name=s.name;
		this.imageFileName=new String();
		this.allRoutes=s.allRoutes;
		this.mapFileName=s.mapFileName;
		this.entries=s.entries;
		this.exits=s.exits;
		this.driverTypes=s.driverTypes;
	}
}


