/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.vehicular.simulator;

import vnsim.map.object.*;

public class Location implements Comparable, java.io.Serializable {

	/** <code>serialVersionUID</code> */
	private static final long serialVersionUID = -5883719321862303634L;
	
	public int roadIdx;
	public int ptIdx;

	public boolean equals(Location loc) {
//		if(loc.roadIdx==this.roadIdx && loc.ptIdx==this.ptIdx) return true;
		Road r1=(Road)Globals.map.roads.get(loc.roadIdx);
		Point pt1=(Point)r1.points.get(loc.ptIdx);
		Road r2=(Road)Globals.map.roads.get(this.roadIdx);
		Point pt2=(Point)r2.points.get(this.ptIdx);
		return pt1.equals(pt2);
	}
	
	public Location(int roadIdx, int ptIdx) {
		this.roadIdx=roadIdx;
		this.ptIdx=ptIdx;
	}

	public int compareTo(Object loc) {
		Location l=(Location) loc;
		if(roadIdx==l.roadIdx) {
			if(ptIdx>l.ptIdx) {
				return 1;
			} else if(ptIdx<l.ptIdx) {
				return -1;
			} else return 0;
		} else {
			if(roadIdx<l.roadIdx) {
				return -1;
			} else 
				return 1;
		}
	}

	public String toString(){
		String ret="";
		ret=ret+"[Rd "+roadIdx+";Pt "+ptIdx+"]";
		return ret;
	}
}